#ifndef DISK_HPP
#define DISK_HPP

#include <syslog.h>
#include <map>
#include <string>
#include <cstring>
#include <glibtop.h>
#include <glibtop/mountlist.h>
#include <glibtop/fsusage.h>
#include <sys/utsname.h>

#include <boost/extension/extension.hpp>
#include <boost/extension/factory.hpp>
#include <boost/extension/type_map.hpp>
#include <boost/property_tree/ptree.hpp>
#include <boost/property_tree/xml_parser.hpp>


#include <plugins/plugin.hpp>

#include <ndds/ndds_cpp.h>
#include "disk_dds.h"
#include "disk_ddsSupport.h"


class disk : public plugin {
public:
  disk(std::string plugin_id);
  virtual void publish_information(void);
  virtual void clean_dds_stuff(void);
private:
  host_info hi_;
  int domain_id_;
  //DDS Stuff
  DDSDomainParticipant *participant_;
  DDSPublisher *publisher_;
  DDSTopic *topic_;
  DDSDataWriter *writer_;
  filesystemDataWriter * filesystem_writer_;
  filesystem *instance_;
  DDS_ReturnCode_t retcode_;
  DDS_InstanceHandle_t instance_handle_;
  const char *type_name_;
  DDS_Duration_t send_period_;
  std::string plugin_id_;
  std::string topic_name_;
  std::string qos_library_;
  std::string qos_profile_;
};


BOOST_EXTENSION_TYPE_MAP_FUNCTION
{
  using namespace boost::extensions;
  std::map<std::string, factory<plugin, std::string> > &plugin_factories(types.get());
  plugin_factories["disk"].set<disk>();
}

#endif //DISK_HPP
